# DataExchange
TKXSBase
IFSelect

# IFSelect_Activator Class Reference

Defines the general frame for working with a SessionPilot.
Each Activator treats a set of Commands. Commands are given as
alphanumeric strings. They can be of two main forms :
- classic, to list, evaluate, enrich the session (by itself) :
no specific remark, its complete execution must be described
- creation of a new item : instead of creatinf it plus adding
it to the session (which is a classic way), it is possible
to create it and make it recorded by the SessionPilot :
then, the Pilot will add it to the session; this way allows
the Pilot to manage itself named items
In order to make easier the use of Activator, this class
provides a simple way to Select an Actor for a Command :
each sub-class of SectionActor defines the command titles it
recognizes, plus attaches a Number, unique for this sub-class,
to each distinct command title.
Each time an action is required, the corresponding Number
can then be given to help the selection of the action to do.
The result of an Execution must indicate if it is worth to be
recorded or not : see method Do
.

`#include <IFSelect_Activator.hxx>`

Inheritance diagram for IFSelect_Activator:

[legend]

## Public Member Functions

Standard_EXPORT void | Add (const Standard_Integer number, const Standard_CString command) const
| Allows a self-definition by an Activator of the Commands it processes, call the class method Adding (mode 0) .
Standard_EXPORT void | AddSet (const Standard_Integer number, const Standard_CString command) const
| Same as Add but specifies that this command is candidate for xset (creation of items, xset : named items; mode 1) .
virtual Standard_EXPORT IFSelect_ReturnStatus | Do (const Standard_Integer number, const Handle(IFSelect_SessionPilot)&pilot)=0
| Tries to execute a Command Line. <number> is the number of the command for this Activator. It Must forecast to record the result of the execution, for need of Undo-Redo Must Returns : 0 for a void command (not to be recorded), 1 if execution OK, -1 if command incorrect, -2 if error on execution .
virtual Standard_EXPORT Standard_CString | Help (const Standard_Integer number) const =0
| Sends a short help message for a given command identified by it number for this Activator (must take one line max) .
Standard_EXPORT Standard_CString | Group () const
Standard_EXPORT Standard_CString | File () const
Standard_EXPORT void | SetForGroup (const Standard_CString group, const Standard_CString file="")
| Group and SetGroup define a "Group of commands" which correspond to an Activator. Default is "XSTEP" Also a file may be attached .
Standard_EXPORT const | Handle (Standard_Type)&DynamicType() const

## Static Public Member Functions

static Standard_EXPORT void | Adding (const Handle(IFSelect_Activator)&actor, const Standard_Integer number, const Standard_CString command, const Standard_Integer mode)
| Records, in a Dictionary available for all the Activators, the command title an Activator can process, attached with its number, proper for this Activator <mode> allows to distinguish various execution modes 0: default mode; 1 : for xset .
static Standard_EXPORT void | Remove (const Standard_CString command)
| Removes a Command, if it is recorded (else, does nothing) .
static Standard_EXPORT void | SetAlias (const Standard_CString conf, const Standard_CString command, const Standard_CString aliasname)
| Records, for a configuration named <conf>, that the command <command> may be aliased by another command <alias> To be used by call to Alias (no automatic redirection) The configuration typically refers to a norm .
static Standard_EXPORT void | SetCurrentAlias (const Standard_CString conf)
| Sets <conf> as current configuration for aliases .
static Standard_EXPORT TCollection_AsciiString | Alias (const Standard_CString command)
| Returns, in the current configuration, what alias has been recorded for <command> The returned string is empty if no alias is recorded .
static Standard_EXPORT Standard_Boolean | Select (const Standard_CString command, Standard_Integer &number, Handle(IFSelect_Activator)&actor)
| Selects, for a Command given by its title, an actor with its command number. Returns True if found, False else .
static Standard_EXPORT Standard_Integer | Mode (const Standard_CString command)
| Returns mode recorded for a command. -1 if not found .
static Standard_EXPORT Handle_TColStd_HSequenceOfAsciiString | Commands (const Standard_Integer mode=-1, const Standard_CString command="")
| Returns, for a root of command title, the list of possible commands. <mode> : -1 (D) for all commands if <commands> is empty -1 + command : about a Group , >= 0 see Adding By default, it returns the whole list of known commands. .

## Protected Member Functions

Standard_EXPORT | IFSelect_Activator ()
| Sets the default values .

## Private Attributes

TCollection_AsciiString | thegroup
TCollection_AsciiString | thefile

## Constructor & Destructor Documentation

Standard_EXPORT IFSelect_Activator::IFSelect_Activator | ( |  | ) | `[protected]`

## Member Function Documentation

Standard_EXPORT void IFSelect_Activator::Add | ( | const Standard_Integer | number,
|  | const Standard_CString | command
| ) | const

static Standard_EXPORT void IFSelect_Activator::Adding | ( | const Handle(IFSelect_Activator)& | actor,
|  | const Standard_Integer | number,
|  | const Standard_CString | command,
|  | const Standard_Integer | mode
| ) | `[static]`

Standard_EXPORT void IFSelect_Activator::AddSet | ( | const Standard_Integer | number,
|  | const Standard_CString | command
| ) | const

static Standard_EXPORT TCollection_AsciiString IFSelect_Activator::Alias | ( | const Standard_CString | command | ) | `[static]`

static Standard_EXPORT Handle_TColStd_HSequenceOfAsciiString IFSelect_Activator::Commands | ( | const Standard_Integer | mode = `-1`,
|  | const Standard_CString | command = `""`
| ) | `[static]`

virtual Standard_EXPORT IFSelect_ReturnStatus IFSelect_Activator::Do | ( | const Standard_Integer | number,
|  | const Handle(IFSelect_SessionPilot)& | pilot
| ) | `[pure virtual]`

| Implemented in IFSelect_Act, IFSelect_SessionPilot, IGESSelect_Activator, and StepSelect_Activator.

Standard_EXPORT Standard_CString IFSelect_Activator::File | ( |  | ) | const

Standard_EXPORT Standard_CString IFSelect_Activator::Group | ( |  | ) | const

Standard_EXPORT const IFSelect_Activator::Handle | ( | Standard_Type |  | ) | const

| Reimplemented in IFSelect_Act, IFSelect_SessionPilot, IGESSelect_Activator, and StepSelect_Activator.

virtual Standard_EXPORT Standard_CString IFSelect_Activator::Help | ( | const Standard_Integer | number | ) | const`[pure virtual]`

| Implemented in IFSelect_Act, IFSelect_SessionPilot, IGESSelect_Activator, and StepSelect_Activator.

static Standard_EXPORT Standard_Integer IFSelect_Activator::Mode | ( | const Standard_CString | command | ) | `[static]`

static Standard_EXPORT void IFSelect_Activator::Remove | ( | const Standard_CString | command | ) | `[static]`

static Standard_EXPORT Standard_Boolean IFSelect_Activator::Select | ( | const Standard_CString | command,
|  | Standard_Integer & | number,
|  | Handle(IFSelect_Activator)& | actor
| ) | `[static]`

static Standard_EXPORT void IFSelect_Activator::SetAlias | ( | const Standard_CString | conf,
|  | const Standard_CString | command,
|  | const Standard_CString | aliasname
| ) | `[static]`

static Standard_EXPORT void IFSelect_Activator::SetCurrentAlias | ( | const Standard_CString | conf | ) | `[static]`

Standard_EXPORT void IFSelect_Activator::SetForGroup | ( | const Standard_CString | group,
|  | const Standard_CString | file = `""`
| ) |

## Field Documentation

TCollection_AsciiString IFSelect_Activator::thefile `[private]`

TCollection_AsciiString IFSelect_Activator::thegroup `[private]`

The documentation for this class was generated from the following file:

- IFSelect_Activator.hxx